﻿Imports C1.Win.TreeView
Imports System
Imports System.ComponentModel
Imports System.Windows.Forms

Namespace TreeViewDemo
    Public Partial Class Form1
        Inherits Form
        Private bl As BindingList(Of ClassData)
        Public Sub New()
            InitializeComponent()
            AddHandler Load, AddressOf Form1_Load
        End Sub

        Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs)
            bl = New BindingList(Of ClassData)()
            bl.Add(New ClassData("0", "1"))
            bl.Add(New ClassData("0", "2"))
            bl.Add(New ClassData("2", "2.1"))
            bl.Add(New ClassData("2", "2.3"))
            bl.Add(New ClassData("0", "3"))

            Dim column = New C1TreeColumn()
            column.DisplayFieldName = "Title"
            column.HeaderText = "Title"
            c1TreeView1.Columns.Clear()
            c1TreeView1.Columns.Add(column)
            c1TreeView1.BindingInfo.KeyField = "Title"
            c1TreeView1.BindingInfo.ParentKeyField = "Parent"
            c1TreeView1.BindingInfo.DataSource = bl
        End Sub

        ''' <summary>
        ''' Need to insert item between 2.1 and 2.3
        ''' </summary>
        ''' <paramname="sender"></param>
        ''' <paramname="e"></param>
        Private Sub Delete_Item(ByVal sender As Object, ByVal e As EventArgs)
            c1TreeView1.Nodes(1).Nodes.RemoveAt(0)

        End Sub
    End Class

    Public Class ClassData
        Implements INotifyPropertyChanged
        Private _parent As String

        Public Property Parent As String
            Get
                Return _parent
            End Get
            Set(ByVal value As String)
                _parent = value
                OnPropertyChanged("Parent")
            End Set
        End Property

        Private _title As String

        Public Property Title As String
            Get
                Return _title
            End Get
            Set(ByVal value As String)
                _title = value
                OnPropertyChanged("Title")
            End Set
        End Property

        Public Sub New(ByVal parent As String, ByVal title As String)
            Me.Parent = parent
            Me.Title = title
        End Sub

        Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
        Private Sub OnPropertyChanged(ByVal propertyname As String)
            RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(propertyname))
        End Sub

    End Class

End Namespace
